#========================================================================================
# package      DE_EPAGES::PayPalPPCP::API::Shop
# state        public
#----------------------------------------------------------------------------------------
# description  Helper subroutines
#========================================================================================
package DE_EPAGES::PayPalPPCP::API::Shop;
use base qw( Exporter );

use strict;
our @EXPORT_OK = qw(
    GetPayPalPPCPScriptTagUrl
);

#========================================================================================
# function GetPayPalPPCPScriptTagUrl
#----------------------------------------------------------------------------------------
# syntax $UnityPayPalPPCPScriptTagUrl = GetPayPalPPCPScriptTagUrl($Shop);
#----------------------------------------------------------------------------------------
# description Returns the URL of the PayPalPPCPScriptTagUrl script tag for Unity shops
#----------------------------------------------------------------------------------------
# input $Shop| shop | object
#----------------------------------------------------------------------------------------
# return $UnityGetPayPalPPCPScriptTagUrlScriptTagUrl | script tag url | string
#========================================================================================
sub GetPayPalPPCPScriptTagUrl {
    my ( $Shop ) = @_;

    return $Shop->get('WebServerScriptName') . '?ViewAction=UnityViewPayPalPPCPScript';
}

1;