sequenceDiagram
autonumber
participant storefront as Storefront
%%participant epages6 as ePages6 <br/> Cartridge
%%participant cartstep as Cart Step
%%participant addressstep as Address Step
%%participant deliverystep as Delivery Step
participant paymentstep as payment Step
participant checkstep as Check & Order Step
participant paypal as PayPal API
participant paypalstep as PayPal Step

participant orderconf as Order Confirmation Page

Note over storefront, paypal: Customer is on the cart page
storefront->>paymentstep: Customer navigates to the payment method selection step
paymentstep->>paymentstep: Customer selects the PayPal PPCP Payment Method option if not already selected
Note over paymentstep: Customer selects a preferred PayPal payment option,<br /> pay on invoice, or ignores selection
paymentstep->>checkstep: Customer navigates to the check & Order step
alt is paying via invoice
  Note over checkstep, orderconf: Customer confirms purchase
  checkstep-->>paypal: Create order with payment source 'Invoice'
  checkstep->>orderconf: if success, show order confirmation
else paypal
  checkstep->>paypalstep: Customer navigates to the ePages hosted PayPal payment page
  Note over paypalstep: Customer approves via their preferred option with the PayPal JS SDK
  paypalstep-->>paypal: Patch order at PayPal if details have changed
  paypalstep-->>paypal: Capture order
  paypalstep->>paypalstep: Execute error on failure
  paypalstep->>orderconf: Basket2Order, redirect to order confirmation page on success
end