#LOCAL("PPCPParameter", #ExtractedPayPalPPCPParameters)
#IF(#PPCPParameter)
(function () {
  var initPayPal = function() {
    var isOk = 1;

    if (window.paypal) {
      try {
        var FUNDING_SOURCES = [
            paypal.FUNDING.PAYPAL,
            paypal.FUNDING.PAYLATER
        ];

        var buttonContainer = 'div#paypal-button-container';
        var payLtrContainerId = 'paypal-button-container';
        FUNDING_SOURCES.forEach(function(fundingSource) {
            var button = paypal.Buttons({
              style: {
                layout: 'vertical',
                color: fundingSource === paypal.FUNDING.PAYPAL || fundingSource === paypal.FUNDING.PAYLATER ? 'gold' : 'white',
                shape: 'rect',
                label: 'paypal',
                height: 55,
              },
              fundingSource: fundingSource,
              createOrder: function (data, actions) {
                return xhrRequest();
              },
              onApprove: function (data, actions) {
                xhrRequestApprove(fundingSource);
              },
              onCancel: function (data, actions) {
                console.log("Customer cancelled the PayPal Checkout Flow");
              },
              onError: function () {
                console.log("An Error occurred as part of the PayPal JS SDK");
              }
            });

            if ( button.isEligible() ) {
                button.render(buttonContainer);
            }
        });

        #REM
            /*
                Pay Later Banner
            */
        #ENDREM
        #IF(#PPCPParameter.EnablePayLaterBanners)
        if ( cart ) {
            if ( document.getElementById(payLtrContainerId) ) {
              document.getElementById(payLtrContainerId).setAttribute('data-pp-amount', cart.grandTotal.amount);
            }
            paypal.Messages({
              style: {
                layout: 'text',
                logo: {
                  type: 'primary'
                },
                text: {
                  align: 'center'
                }
              },
            }).render(buttonContainer);
        }
        #ENDIF

      } catch (e) {
        isOk = 0;
        console.log(e);
      }
    } else {
      isOk = 0;
    }

    if (!isOk) {
      #REM
      //document.getElementById('#'+'PayPalPPCPErrorLink').style.display = 'block';
      //console.log('IS_NOT OK', document.getElementById('#'+'PayPalPPCPErrorLink'));
      #ENDREM
    }
  },

  xhrRequest = function() {
    return new Promise(function(resolve, reject) {
      if (XMLHttpRequest && cart) {
        var xhr = new XMLHttpRequest(),
          targetUrl = '#PPCPParameter.CreateOrderUrl[0]',
          data = {
            'BasketGUID': cart.cartId,
          };

        xhr.open('POST', targetUrl, true);
        xhr.setRequestHeader('Content-Type', 'application/json');

        xhr.addEventListener('load', function () {
          if (xhr.status < 200 || xhr.status >= 300) {
            reject(new Error(xhr.responseText + xhr.statusText));
          } else {
            try {
              var response = JSON.parse(xhr.responseText);

              if (response.success) {
                resolve(response.orderID);
              } else {
                reject(new Error(xhr.responseText + xhr.statusText));
              }
            } catch (e) {
              reject(e);
            }
          }
        });

        xhr.send(JSON.stringify(data));
      }
    })
  },

  xhrRequestApprove = function(fundingSource) {
    if (XMLHttpRequest && cart) {
      var xhr = new XMLHttpRequest(),
        targetUrl = '#PPCPParameter.ApproveOrderUrl[0]',
        data = {
          'PickupToken': '#PPCPParameter.ApprovePPCPToken',
          'BasketGUID': cart.cartId,
          'LocaleID': shopLocale,
          'FundingSource': fundingSource,
        };

      xhr.open('POST', targetUrl, true);
      xhr.setRequestHeader('Content-Type', 'application/json');

      xhr.addEventListener('load', function () {
        if (xhr.status < 200 || xhr.status >= 300) {
          console.warn(new Error(xhr.responseText + xhr.statusText));
        } else {
          try {
            var response = JSON.parse(xhr.responseText);

            if (response.success) {
              window.location = response.redirect;
            } else {
              console.warn(new Error(xhr.responseText + xhr.statusText));
            }
          } catch (e) {
            console.log(e);
          }
        }
      });

      xhr.send(JSON.stringify(data));
    }
  };

  if (window.eComEventTarget) {
    var cart,
        script,
        shopLocale;

    #REM
        /* Product page bannerz */
    #ENDREM
    #IF(#PPCPParameter.EnablePayLaterBanners)
      document.head.insertAdjacentHTML('beforeend', '<style>div.product-button-container span[id*="zoid-paypal-message"]{margin-top: 20px;}</style>');
      window.eComEventTarget.addEventListener('product:view', function(event) {
        var product = event.detail.product;
        var containerElem = document.getElementsByClassName('product-button-container');
        if ( containerElem ) {
          try {
            containerElem[0].setAttribute('data-pp-amount', product.price.amount);
          } catch {
          }

          paypal.Messages({
              style: {
                layout: 'text',
                logo: {
                  type: 'primary'
                }
              },
          }).render('div.product-button-container');
        }
      });
    #ENDIF

    window.eComEventTarget.addEventListener('cart:view', function(event) {
      cart = event.detail.cart;
      shopLocale = event.detail.shopLocale;

      if (window.paypal) {
        initPayPal();
      }
    });

    #REM
        /* only needed if banners are to be shown */
    #ENDREM
    #IF(#PPCPParameter.EnablePayLaterBanners)
    window.eComEventTarget.addEventListener('cart:update', function(event) {
      cart = event.detail.cart;
      var btnContainer = document.getElementById('paypal-button-container');
      if ( btnContainer ) {
        btnContainer.setAttribute('data-pp-amount', cart.grandTotal.amount);
      }
    });
    #ENDIF

    script = document.createElement('script');
    script.src = 'https://www.paypal.com/sdk/js?#IF(#PayPalPPCPIntegrationDate)integration-date=#PayPalPPCPIntegrationDate&#ENDIF#SPACE[0]client-id=#PPCPParameter.ClientID&currency=#PPCPParameter.CurrencyID&intent=capture&components=buttons,funding-eligibility#IF(#PPCPParameter.EnablePayLaterBanners),messages#ENDIF#IF(#PPCPParameter.EnablePayLater)&enable-funding=paylater#ENDIF';
    script.setAttribute("defer", true);
    script.setAttribute('data-partner-attribution-id', '#PPCPParameter.PartnerBNCode');
    document.body.appendChild(script);

    #REM
        /* pay later message span tags are displayed inline, causing it to be too wide, also affecting the buttons above it, so make it a block element instead */
    #ENDREM
    document.head.insertAdjacentHTML('beforeend', '<style>div#paypal-button-container span[id*="zoid-paypal-message"]{display: block;}</style>');

    #REM
    /*
    script.onload = function() {
      setTimeout(function () {
        if (!window.paypal) {
          initPayPal();
        }
      }, 1000);
    }
    */
    #ENDREM
  }
})();
#ENDIF
#ENDLOCAL #REM /* LOCAL("PPCPParameter", ExtractedPayPalPPCPParameters) */ #ENDREM
